﻿using DataTransmission.Enum;
using Hotline.Snapshot;
using Mapster;
using SnapshotWinFormsApp.Application.Dtos;
using SnapshotWinFormsApp.Entities.NewHotline;
using SnapshotWinFormsApp.Entities.OldHotline;
using SqlSugar.Extensions;

namespace SnapshotWinFormsApp.Tools;

public static class MapsterConfig
{
    public static void RegisterMappings()
    {
        TypeAdapterConfig<SSP_AreaUserEntity, Practitioner>.NewConfig()
            .Map(m => m.CreationTime, n => n.InsertTime.ObjToDate())
            .Map(m => m.PhoneNumber, n => n.Tel)
            .Map(m => m.Street, n => n.AreaTown)
            .Map(m => m.SystemAreaName, n => n.AreaName)
            .Map(m => m.Gender, n => n.Sex.Trim() == "男" ? EGender.Male : EGender.Female);

        TypeAdapterConfig<WeChatUserEntity, ThirdAccount>.NewConfig()
            .Map(m => m.UserName, n => n.WUR_WebUserName)
            .Map(m => m.OpenId, n => n.WUR_Openid)
            .Map(m => m.UnIonId, n => n.WUR_unionid)
            .Map(m => m.CreationTime, n => n.WUR_RegDate);

        TypeAdapterConfig<WeChatUserEntity, Citizen>.NewConfig()
            .Map(m => m.CreationTime, n => n.WUR_RegDate)
            .Map(m => m.PhoneNumber, n => n.WUR_PhoneNum)
            .Map(m => m.Name, n => n.WUR_WebUserName);

        TypeAdapterConfig<WeChatUserDto, ThirdAccount>.NewConfig()
            .Map(m => m.PhoneNumber, n => n.WUR_PhoneNum)
            .Map(m => m.UserName, n => n.WUR_WebUserName)
            .Map(m => m.CreationTime, n => n.WUR_RegDate)
            .Map(m => m.OpenId, n => n.WUR_Openid)
            .Map(m => m.UnIonId, n => n.WUR_unionid);

        TypeAdapterConfig<SSP_AreaEntity, CommunityInfo>.NewConfig()
            .Map(m => m.CreationTime, n => n.InsertTime)
            .Map(m => m.Name, n => n.Areaname)
            .Map(m => m.Id, n => n.Areaid)
            .Map(m => m.ParentCode, n => n.Areapid)
            .Map(m => m.DepartmentNo, n => n.Areadepartmentno)
            .Map(m => m.FullName, n => n.Areafullname);

        TypeAdapterConfig<SSP_InviteEntity, InviteCode>.NewConfig()
            .Map(m => m.BeginCode, n => n.SIC_Code)
            .Map(m => m.EndCode, n => n.SIC_Code2)
            .Map(m => m.OrgName, n => n.SIC_BMName)
            .Map(m => m.QRCodeUrl, n => n.SIC_imgUrl);

        TypeAdapterConfig<SSP_InviteLogEntity, InviteCodeRecord>.NewConfig()
            .Map(m => m.WXOpenId, n => n.SSPI_Openid)
            .Map(m => m.InviteCode, n => n.SSPI_Code)
            .Map(m => m.CreationTime, n => n.SSPI_AddTime);
    }
}
